package cn.gygxzc.envir.core.utils;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.stereotype.Component;

/**
 * Created by niantuo on 2018/11/5.
 * 获取bean类
 */
@Component
public class ApplicationUtils implements ApplicationContextAware {

    private static ApplicationContext mContext;
    private final static Logger logger = LoggerFactory.getLogger(ApplicationUtils.class);


    /**
     * @param clz s
     * @param <T>
     * @return
     */
    public static <T> T getBean(Class<T> clz) {
        if (mContext == null) return null;
        try {
            return mContext.getBean(clz);
        } catch (Exception ignored) {
            logger.info("no bean found {}",clz.getName());
        }
        return null;
    }

    @Override
    public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
        mContext = applicationContext;
    }
}
